#include<stdio.h>
#include<dir.h>
#include<string.h>

#define word  unsigned int
#define dword unsigned long
#define byte  unsigned char

byte reverse(byte b){
byte r=0;
int i;
for(i=0;i<8;i++)
  r|=(((b & (1U << i))?1U:0) << (7-i));
return r;}

int main(int argc, char **argv){
char drive[MAXDRIVE];
char dir[MAXDIR];
char file[MAXFILE];
char ext[MAXEXT];
char filename[MAXPATH];
byte map[2048];
char fontname[259]={0};
FILE *pf;
int fsize[]={0,0,0,0,0,0,2688,2945,3202};
int i;
byte height, id, nchars;
word nchars2;
byte buffer[1140]={0};
word *wbuffer;
word cTable[2];

wbuffer=(word *)buffer;

if (argc>1)
  strcpy(filename,argv[1]);
else{
  puts("\nFile name?");
  gets(filename);}

if((pf=fopen(filename,"rb"))==NULL){
  puts("\nUnable to open file");
  return -1;}
fseek(pf,13L,SEEK_SET);
fread(&height,1,1,pf);
fread(&id,1,1,pf);
fread(&nchars,1,1,pf);
fontname[0]='4';
fontname[1]='9';
fontname[2]='_';
fread(fontname+3,1,nchars,pf);
fread(&i,1,1,pf);
fread(map,8,256,pf);
fclose(pf);
for(i=0;i<2048;i++)
  map[i]=reverse(map[i]);

if(argc<3){
  puts(fontname+3);
  for(i=0;i<strlen(fontname)-3;i++)
    putchar('*');
  puts(" New font name (or ENTER to accept):");
  gets(buffer);
  if(strlen(buffer)){
    strcpy(fontname+3,buffer);
    nchars=strlen(buffer);}
  }

fnsplit(argv[0],drive,dir,file,ext);
fnmerge(buffer,drive,dir,"data",".dat");
if((pf=fopen(buffer,"rb"))==NULL){
  puts("\nDATA.DAT not found");
  return -3;}
fread(buffer,299,1,pf);
nchars2=nchars+23;
if (nchars2>255)
  nchars2=255;
buffer[278]=nchars2;
strncpy(buffer+299,fontname,nchars2-20);
wbuffer[80]=nchars2+4;
wbuffer[101]=(279+nchars2)/16+1;
wbuffer[102]=(118+nchars+2)/16+1;
wbuffer[111]=wbuffer[101]+wbuffer[102];
wbuffer[112]=(fsize[height]+nchars)/16+1;
if(!id) id=height;
buffer[228]=id;
wbuffer[121]=wbuffer[111]+wbuffer[112];
wbuffer[122]=(451+(nchars/4+1)*4+(strlen(file)/4+2)*4)/16+1;
wbuffer[wbuffer[101]*8]=1;
wbuffer[wbuffer[101]*8+1]=id;
fread(buffer+wbuffer[101]*16+4,1,570,pf);
wbuffer[wbuffer[101]*8+39]=height-1;
wbuffer[wbuffer[101]*8+46]=height;
wbuffer[wbuffer[101]*8+3]=fsize[height]+nchars+4;
wbuffer=(word *)(buffer+wbuffer[101]*16+109);
*wbuffer=fsize[height];
wbuffer=(word *)buffer;
wbuffer=(word *)buffer[wbuffer[101]*16+4+118];
wbuffer[0]=452+(nchars/4+1)*4+(strlen(file)/4+2)*4;
wbuffer[34]=wbuffer[0]-110;
wbuffer[44]=wbuffer[34]-20;
wbuffer[73]=24+(nchars/4+1)*4;
wbuffer[72]=wbuffer[73]+20;
wbuffer[153]=(strlen(file)/4+2)*4;
wbuffer[152]=wbuffer[153]+24;
wbuffer=(word *)buffer;
fclose(pf);

fnsplit(filename,drive,dir,file,ext);
strcpy(ext,strcmpi(ext,".FON")?".FON":".WFN");
fnmerge(filename,drive,dir,file,ext);
if((pf=fopen(filename,"wb"))==NULL){
  puts("\nUnable to open output file");
  return -2;}

fwrite(buffer,wbuffer[101]*16+117,1,pf);
fwrite(buffer+1124,1,1,pf);
fwrite(fontname,1,nchars+3,pf);
fwrite(buffer+1124,wbuffer[102]*16-(121+nchars),1,pf);
fwrite(buffer+wbuffer[101]*16+4,118,1,pf);
cTable[0]=6;
cTable[1]=1146;
for(i=0;i<257;i++){
  fwrite(cTable,4,1,pf);
  cTable[1]+=height;}
for(i=0;i<256;i++)
  fwrite(map+8*i,height,1,pf);
fwrite(buffer+1124,1,height,pf);
fwrite(fontname,1,nchars+3,pf);
fwrite(buffer+1124,wbuffer[121]*16-ftell(pf),1,pf);
fwrite(buffer+wbuffer[101]*16+122,188,1,pf);
fwrite(fontname+3,1,nchars,pf);
fwrite(buffer+1124,1,(nchars/4+1)*4-nchars,pf);
fwrite(buffer+wbuffer[101]*16+122+188,140,1,pf);
fwrite(file,1,strlen(file),pf);
fwrite(ext,1,4,pf);
fwrite(buffer+1124,1,(strlen(file)/4+1)*4-strlen(file),pf);
fwrite(buffer+wbuffer[101]*16+122+188+140,124,1,pf);
fwrite(buffer+1124,1,(wbuffer[121]+wbuffer[122])*16-ftell(pf),pf);
fclose(pf);

return 0;}